#' Create and check constraint region of interest
#'
#' When creating a SDM, you need to constrain your area of interest. It can be
#' done in different ways. One, is adding a constrain region, either uploading
#' a file or drawing a region on the map. The other way is creating a convex
#' hull, where you can specify the buffer radius to use. If no constrained
#' region is specified, a convex hull will be automatically generated.
#'
#' This function creates a constraint region, checks projections, creates a
#' buffer to avoid missing environment values along the boundary of the
#' constrained region, constrains presence/absence points, and returns a list
#' with a masked raster stack and constrained presence/absence points.
#'
#' NOTE that for single-species SDM the convex hull will always be FALSE, as 
#' the convex-hull polygon is generated by the front-end and passed in as
#' constraint. It will be TRUE for multi species (MSDM), where the convex hull
#' needs to be generated for each individual species.
#'
#' @param current_climate raster stack from dataset
#' @param occurrences species occurrence data, if available; optional month
#' filtering
#' @param absences species absence species data, if available; optional month
#' filtering
#' @param constraints geographic constraint region, from constraint
#' @param region_offset region offset, from constraint; can be "0"
#' @param create_convex_hull TRUE or FALSE argument to generate convex hull,
#' @param bias_layer raster bias layer for Maxent background points
#' from constraint
#
#' @importFrom geojsonsf geojson_sf
#' @importFrom geojsonsf sf_geojson
#' @importFrom geojsonsf geojson_wkt
#' @importFrom rjson fromJSON
#' @importFrom rgeos gBuffer
#' @importFrom sf st_as_sf
#' @importFrom sf st_coordinates
#' @importFrom sf st_crs
#' @importFrom sf st_union
#' @importFrom sf st_convex_hull
#' @importFrom sf st_intersection
#' @importFrom sf st_within
#' @importFrom terra crop
#' @importFrom terra vect
#' @importFrom terra mask
#'
#' @export EC_SDM_geoconstrained
#' @export EC_geojson_to_sf
#' @export EC_constraints_from_points
EC_SDM_geoconstrained <- function(EC.env,
                                  current_climate,
                                  occurrences = NULL,
                                  absences = NULL,
                                  constraints = NULL,
                                  prediction_constraint = NULL,
                                  region_offset,
                                  create_convex_hull = NULL,
                                  bias_layer = NULL) {
  # NOTE: some code has been removed:
  # 1. check the CRS of the climate layers which would have been 
  # reprojected to that of the base layer or 4326 at this stage.
  climate_crs <- terra::crs(current_climate, describe = TRUE)$code
  
  # 2. adding buffers to regions to ensure climate data sampled correctly
  #    this should be an argument to the extraction function for climate 
  #    projections, occur *will be* missing
  
  # create constraint region if required
  if (is.null(occurrences)) {
    if (is.null(constraints)) {
      constrained_region <- NULL
    } else {
      constrained_region <- EC_geojson_to_sf(constraints)
      
      # convert the constrained region to the CRS of the environmental data
      if (terra::crs(constrained_region, describe = TRUE)$code != 
          climate_crs) {
        cat("Reprojecting constraint from (EPSG:)",
            terra::crs(constrained_region, describe = TRUE)$code,
            "to epsg:", climate_crs, "\n"
        )
        constrained_region <- sf::st_transform(
          constrained_region, crs = paste0("EPSG:", climate_crs))
      }
      
      # Ensure all longitudes are from -180 to 180 degrees
      constrained_region <- sf::st_wrap_dateline(constrained_region)
      if (length(sf::st_coordinates(constrained_region)) == 0) {
        stop(paste("Cannot resolve study area constraint. Please ensure", 
                   "longitudes are between -180 and 180 degrees."), 
             call. = FALSE)
      }
    }
  } else { # i.e. if occurrences are given
    
    # transform your occurrence data to sf. If "species" is a field, remove
    # before that
    if (!is.null(occurrences$species)) {
      keeps <- c("lon", "lat")
      occurrences <- occurrences[keeps]
    }
    # Note: EC_read_sf will read the occurrences in to the same crs as the 
    # environmental layers so can reference it here.
    occurrences_sf <- sf::st_as_sf(
      occurrences,
      coords = c("lon", "lat"), crs = sf::st_crs(as.numeric(climate_crs))
    )
    
    # Note: We have access to current_climate layers, which should be in correct
    # projection by now. So we can re-project the points to this projection
    # Note: this will only be needed when custom CRS handling is implemented
    constrained_region <- EC_constraints_from_points(
      occurrences_sf,
      current_climate,
      constraints,
      create_convex_hull
    )
    
    # Ensure all longitudes are from -180 to 180 degrees
    if (!is.null(constrained_region)) {
      constrained_region <- sf::st_wrap_dateline(constrained_region)
      if (length(sf::st_coordinates(constrained_region)) == 0) {
        stop(paste("Cannot resolve study area constraint. Please ensure", 
                   "longitudes are between -180 and 180 degrees."), 
             call. = FALSE)
      }
      
      # currently, point constraint only occurs for the training regions
      # this means that model performance can only be assessed in the 
      # training region. Later, we can look into taking a second set of 
      # points, either in the prediction region or elsewhere to assess
      # model performance. Until then, there is no need to allow points
      # points to be available in the prediction region.
      
      # constrain occurrence points to those within the constrained region
      # occurrences_sf <- occurrences_sf[as.data.frame(
      #  st_within(occurrences_sf, constrained_region)
      # )$row.id, ]
      # Alternative (using terra)
      occurrences_sf <- sf::st_as_sf(
        terra::intersect(terra::vect(occurrences_sf), 
                         terra::vect(constrained_region))[,1])
    }
  }
  
  # constrain the true absence points, if available
  if (!is.null(constrained_region) &&
      !is.null(absences) &&
      nrow(absences) > 0) {
    absences_sf <- sf::st_as_sf(absences,
                                coords = c("lon", "lat"),
                                crs = sf::st_crs(as.numeric(climate_crs))
    )
    
    # absences_sf <- absences_sf[as.data.frame(
    #   st_within(absences_sf, constrained_region)
    # )$row.id, ]
    absences_sf <- sf::st_as_sf(
      terra::intersect(terra::vect(absences_sf), 
                       terra::vect(constrained_region))[,1])
    
    # save output as csv -- TEMP DISABLED
    # this was in the source code, but fails as filename not established
    # anywhere? Unsure if this is left over from something, something that
    # should be fixed, or something that can be deleted
    
    # absences_out <- st_coordinates(absences_sf)
    # colnames(absences_out) <- c("lon", "lat")
    # write.csv(absences_out, file = absenFilename, row.names= FALSE)
  } else {
    absences_sf <- NULL
  }
  
  # save out modified region to a new file
  # if directory does not exist, create it
  if (!dir.exists(file.path2(EC.env$outputdir))) {
    dir.create(file.path2(EC.env$outputdir))
  }
  
  filename <- file.path2(EC.env$outputdir, "modelling_region.json")
  
  write(geojsonsf::sf_geojson(constrained_region), filename)
  
  # Crop and mask the raster stack to the region of interest
  
  # do twice, once for training and again for prediction region
  # create constrained prediction region if required.
  # This one is irrespective of occurrence values
  if (!is.null(prediction_constraint)) {
    prediction_region <- EC_geojson_to_sf(prediction_constraint)
    
    # convert the constrained region to the CRS of the environmental data
    if (terra::crs(prediction_region, describe = TRUE)$code != 
        climate_crs) {
      cat("Reprojecting prediction constraint from (EPSG:)",
          terra::crs(prediction_region, describe = TRUE)$code,
          "to epsg:", climate_crs, "\n"
      )
      prediction_region <- sf::st_transform(prediction_region, 
                                            crs = paste0("EPSG:", climate_crs))
    }
    
    # Ensure all longitudes are from -180 to 180 degrees
    prediction_region <- sf::st_wrap_dateline(prediction_region)
    if (length(sf::st_coordinates(prediction_region)) == 0) {
      stop(paste("Cannot resolve study area constraint. Please ensure", 
                 "longitudes are between -180 and 180 degrees."), 
           call. = FALSE)
    }
    
    #saved the prediction region to the output directory too
    filename <- file.path2(EC.env$outputdir, "prediction_region.json")
    
    write(geojsonsf::sf_geojson(prediction_region), filename)
  } else {
    prediction_region <- NULL
  } 
  
  # created a list containing the training and prediction regions
  study_region <- list("training_region" = constrained_region,
                       "prediction_region" = prediction_region)
  
  # Create a list indicating if constraint method is environmental envelope
  is_environ_envelope <- list(
    "training_region" = 
      (!is.null(attr(constraints, "method")) &&
         attr(constraints, "method") == "environmental envelope"),
    "prediction_region" = 
      (!is.null(attr(prediction_constraint, "method")) &&
         attr(prediction_constraint, "method") == "environmental envelope")
  )
  
  # perform constraint. iterate through the training an prediction regions
  # if they exist
  for (region in labels(study_region)) {
    
    # Apply when constraint is not environmental envelope
    if (!is.null(study_region[[region]]) && !is_environ_envelope[[region]]) {

      # Use windowing rather than cropping
      orig_ext <- terra::ext(current_climate)
      terra::window(current_climate) <- 
        terra::ext(terra::vect(study_region[[region]]))
      
      # Mask and crop climate layers (via window)
      cropped_raster <- list()
      file_pat <- paste0(EC.env$outputdir, "/", region, "_cropped_raster_")
      for (i in 1:terra::nlyr(current_climate)) {
        
        # File name
        if (region == "training_region" && 
            terra::is.factor(current_climate[[i]])) {
          file_name <- paste0(file_pat, i, "_tmp.tif") # temp file
        } else {
          file_name <- paste0(file_pat, i, ".tif")
        }
        
        # hotfix: need to specify datatype here, otherwise because of small
        # file size it will assumed unsiged 8 bit but this won't work for 
        # layers such as bioclim_12 with values > 255
        suppressWarnings(
          cropped_raster[[i]] <- terra::mask(
            current_climate[[i]],
            terra::vect(study_region[[region]]),
            datatype = "FLT4S",
            filename = file_name,
            overwrite = TRUE)
        )
        
        # Drop unused levels for training region 
        # (important for categorical layers)
        if (region == "training_region" && 
            terra::is.factor(cropped_raster[[i]])) {
          
          cropped_raster_new <- EC_drop_unused_levels(cropped_raster[[i]])
          
          # Re-write new
          file_name_new <- paste0(file_pat, i, ".tif") # re-write to new
          cropped_raster_new <- terra::writeRaster(cropped_raster_new,
                                                   filename = file_name_new,
                                                   datatype = "FLT4S",
                                                   overwrite = TRUE)
          
          # Delete temp files
          unlink(terra::sources(cropped_raster[[i]]))
          xml_file_pat <- paste0(region, "_cropped_raster_", i, "_tmp.*.xml")
          xml_files <- list.files(EC.env$outputdir,
                                  pattern = xml_file_pat,
                                  full.names = TRUE
          )
          if (length(xml_files) > 0) {
            unlink(xml_files)
          }
          
          # Reassign
          cropped_raster[[i]] <- cropped_raster_new
        }
      }
      
      # Reset window to full original extent
      terra::window(current_climate) <- NULL
      terra::window(current_climate) <- orig_ext
      
      # rewrite the study region list with the cropped rasters
      study_region[[region]] <- terra::rast(cropped_raster)
    
    } else if (is_environ_envelope[[region]]) {
      
      # Use original climate data when constraint is environmental envelope
      study_region[[region]] <- current_climate
    }
  }
  
  occur <- if (!is.null(occurrences)) {
    x <- sf::st_coordinates(occurrences_sf)
    colnames(x) <- c("lon", "lat")
    occur <- x
  }
  
  absen <- if (!is.null(absences_sf)) {
    x <- sf::st_coordinates(absences_sf)
    colnames(x) <- c("lon", "lat")
    absen <- x
  }
  
  if (!is.null(bias_layer)) {
    suppressWarnings(
      bias_layer <- terra::crop(bias_layer,
                                terra::vect(constrained_region),
                                mask = TRUE,
                                datatype = "FLT4S",
                                filename = file.path(EC.env$outputdir, 
                                                     "bias_layer.tif"),
                                overwrite = TRUE
      )
    )
  }
  
  # Return the masked raster stack and constrained occurrence points
  mylist <- list(
    "masked_raster" = study_region$training_region,
    "prediction_raster" = study_region$prediction_region,
    "occur" = occur,
    "absen" = absen,
    "bias_layer" = bias_layer
  )
  
  return(mylist)
}

#' Convert a geojson string to an sf object
#'
#' This function converts a geojson string to an sf object
#'
#' @param constraints A geojson string describing the constraint region
#'
#' @return An sf object
EC_geojson_to_sf <- function(constraints) {
  crs_regex <- gregexpr(",\"crs", constraints)[[1]]
  # if a crs is given, parse carefully
  if (crs_regex > 0) {
    # extract coords as wkt
    coords_json <- paste0(substr(constraints, 1, crs_regex - 1), "}")
    coords_wkt <- geojsonsf::geojson_wkt(coords_json)
    coords_wkt_string <- gsub("list\\(\"|\"\\)", "", as.character(coords_wkt))
    # extract crs as a string
    crs_json <- paste0(
      "{",
      substr(constraints, crs_regex + 1, nchar(constraints) - 1)
    )
    crs_string <- jsonlite::fromJSON(crs_json)$crs$properties$name
    # use sf to import wkt as a data.frame
    st_as_sf(
      data.frame(wkt = coords_wkt_string),
      wkt = "wkt",
      crs = sf::st_crs(crs_string)
    )
    # if no crs provided, import directly using `geojsonsf`
    # assuming that crs is 4326 if not specified.
  } else {
    geojsonsf::geojson_sf(constraints)
  }
}

#' Create a constrained region from a set of points
#'
#' This function creates a constrained region from a set of points
#' and a set of constraints. If no constraints are provided, the convex hull
#' of the points is used as the constrained region. If constraints are
#' provided, the convex hull of the points is intersected with the constraints.
#'
#' @param points A \code{sf}? object containing the points to be used to create
#' the constrained region.
#' @param current_climate A rater stack containing the current climate data.
#' @param constraints A \code{sf}? object containing the constraints to be used
#' to create the constrained region.
#' @param create_convex_hull A logical indicating whether the convex hull of
#' the points should be used as the constrained region.
#' @return Object containing the constrained region.
EC_constraints_from_points <- function(points,
                                       current_climate,
                                       constraints,
                                       create_convex_hull) {
  if (is.null(constraints)) {
    if (create_convex_hull) {
      constrained_region <- sf::st_convex_hull(st_union(points))
    } else {
      constrained_region <- NULL
    }
  } else { # i.e. if constraints exist
    parsed_geojson <- EC_geojson_to_sf(constraints)
    if (create_convex_hull) {
      constrained_region <- st_intersection(
        sf::st_convex_hull(st_union(points)),
        parsed_geojson
      )
      constrained_region <- rgeos::gBuffer(
        constrained_region, 
        width = max(region_offset, max(res(current_climate)))
      )
    } else {
      constrained_region <- parsed_geojson
    }
    
    # convert the constrained region to the CRS of the environmental data
    if (terra::crs(constrained_region, describe = TRUE)$code != 
        terra::crs(current_climate, describe = TRUE)$code) {
      cat("Reprojecting constraint from (EPSG:)",
          terra::crs(constrained_region, describe = TRUE)$code,
          "to epsg:", 
          terra::crs(current_climate, describe = TRUE)$code, "\n"
      )
      constrained_region <- sf::st_transform(
        constrained_region, 
        crs = paste0("EPSG:", 
                     terra::crs(current_climate, describe = TRUE)$code))
    }
  }
  return(constrained_region)
}